﻿/*
        Uploads (Upload files via http)
        Copyright (C) 2024  Tesses

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
using Tesses.WebServer;

RouteServer routeServer=new RouteServer();
routeServer.Add("/",async(ctx)=>{
    await ctx.SendTextAsync("<!DOCTYPE html><html><head><title>Upload files</title></head><body><h1>Upload Files</h1><form action=\"./upload.cgi\" method=\"post\" enctype=\"multipart/form-data\"><input type=\"file\" name=\"file\" multiple><input type=\"submit\" value=\"Upload\"></form></body></html>");
});
routeServer.Add("/upload.cgi",async(ctx)=>{
    using var res=ctx.ParseBodyWithTempDirectory(Path.Combine(Environment.CurrentDirectory,$"TEMP_{DateTime.Now.ToString("yyyyMMdd_HHmmss")}"));
   
    Directory.Move(res.Directory,Path.Combine(Environment.CurrentDirectory,$"{DateTime.Now.ToString("yyyyMMdd_HHmmss")}"));
    await ctx.SendTextAsync("<!doctype html><html><head><title>Success</title></head><body><h1>Success</h1><a href=\"./\">Go Back</a></body></html>");
},"POST");

routeServer.StartServer(49992);